diff -pruN 0.15+dfsg-1/config.h.in 0.15.1+dfsg-1/config.h.in
--- 0.15+dfsg-1/config.h.in	2020-09-23 14:48:56.000000000 +0000
+++ 0.15.1+dfsg-1/config.h.in	2020-11-03 15:18:14.000000000 +0000
@@ -36,6 +36,12 @@
 /* Define to 1 if you have the `issetugid' function. */
 #undef HAVE_ISSETUGID
 
+/* Define if libkrun is available */
+#undef HAVE_LIBKRUN
+
+/* Define to 1 if you have the <libkrun.h> header file. */
+#undef HAVE_LIBKRUN_H
+
 /* Define to 1 if you have the <linux/bpf.h> header file. */
 #undef HAVE_LINUX_BPF_H
 
diff -pruN 0.15+dfsg-1/configure 0.15.1+dfsg-1/configure
--- 0.15+dfsg-1/configure	2020-09-23 14:48:56.000000000 +0000
+++ 0.15.1+dfsg-1/configure	2020-11-03 15:18:14.000000000 +0000
@@ -1,6 +1,6 @@
 #! /bin/sh
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.69 for crun 0.15.
+# Generated by GNU Autoconf 2.69 for crun 0.15.1.
 #
 # Report bugs to <giuseppe@scrivano.org>.
 #
@@ -590,8 +590,8 @@ MAKEFLAGS=
 # Identity of this package.
 PACKAGE_NAME='crun'
 PACKAGE_TARNAME='crun'
-PACKAGE_VERSION='0.15'
-PACKAGE_STRING='crun 0.15'
+PACKAGE_VERSION='0.15.1'
+PACKAGE_STRING='crun 0.15.1'
 PACKAGE_BUGREPORT='giuseppe@scrivano.org'
 PACKAGE_URL=''
 
@@ -798,6 +798,7 @@ enable_dependency_tracking
 enable_silent_rules
 enable_maintainer_mode
 enable_caps
+with_libkrun
 enable_seccomp
 enable_systemd
 enable_bpf
@@ -1364,7 +1365,7 @@ if test "$ac_init_help" = "long"; then
   # Omit some internal or obsolete options to make the list less imposing.
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-\`configure' configures crun 0.15 to adapt to many kinds of systems.
+\`configure' configures crun 0.15.1 to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
 
@@ -1434,7 +1435,7 @@ fi
 
 if test -n "$ac_init_help"; then
   case $ac_init_help in
-     short | recursive ) echo "Configuration of crun 0.15:";;
+     short | recursive ) echo "Configuration of crun 0.15.1:";;
    esac
   cat <<\_ACEOF
 
@@ -1473,6 +1474,7 @@ Optional Packages:
   --with-gnu-ld           assume the C compiler uses GNU ld [default=no]
   --with-sysroot[=DIR]    Search for dependent libraries within DIR (or the
                           compiler's sysroot if not specified).
+  --with-libkrun          build with libkrun support
   --with-python-bindings  build the Python bindings
 
 Some influential environment variables:
@@ -1566,7 +1568,7 @@ fi
 test -n "$ac_init_help" && exit $ac_status
 if $ac_init_version; then
   cat <<\_ACEOF
-crun configure 0.15
+crun configure 0.15.1
 generated by GNU Autoconf 2.69
 
 Copyright (C) 2012 Free Software Foundation, Inc.
@@ -1935,7 +1937,7 @@ cat >config.log <<_ACEOF
 This file contains any messages produced by compilers while
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by crun $as_me 0.15, which was
+It was created by crun $as_me 0.15.1, which was
 generated by GNU Autoconf 2.69.  Invocation command line was
 
   $ $0 $@
@@ -11879,7 +11881,7 @@ fi
 
 # Define the identity of the package.
  PACKAGE='crun'
- VERSION='0.15'
+ VERSION='0.15.1'
 
 
 cat >>confdefs.h <<_ACEOF
@@ -13415,6 +13417,30 @@ fi
 
 fi
 
+
+# Check whether --with-libkrun was given.
+if test "${with_libkrun+set}" = set; then :
+  withval=$with_libkrun;
+fi
+
+if test "x$with_libkrun" = "xyes"; then :
+  for ac_header in libkrun.h
+do :
+  ac_fn_c_check_header_mongrel "$LINENO" "libkrun.h" "ac_cv_header_libkrun_h" "$ac_includes_default"
+if test "x$ac_cv_header_libkrun_h" = xyes; then :
+  cat >>confdefs.h <<_ACEOF
+#define HAVE_LIBKRUN_H 1
+_ACEOF
+
+$as_echo "#define HAVE_LIBKRUN 1" >>confdefs.h
+
+else
+  as_fn_error $? "*** Missing libkrun headers" "$LINENO" 5
+fi
+
+done
+
+fi
 # Check whether --enable-seccomp was given.
 if test "${enable_seccomp+set}" = set; then :
   enableval=$enable_seccomp;
@@ -15041,7 +15067,7 @@ cat >>$CONFIG_STATUS <<\_ACEOF || ac_wri
 # report actual input values of CONFIG_FILES etc. instead of their
 # values after options handling.
 ac_log="
-This file was extended by crun $as_me 0.15, which was
+This file was extended by crun $as_me 0.15.1, which was
 generated by GNU Autoconf 2.69.  Invocation command line was
 
   CONFIG_FILES    = $CONFIG_FILES
@@ -15107,7 +15133,7 @@ _ACEOF
 cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
 ac_cs_config="`$as_echo "$ac_configure_args" | sed 's/^ //; s/[\\""\`\$]/\\\\&/g'`"
 ac_cs_version="\\
-crun config.status 0.15
+crun config.status 0.15.1
 configured by $0, generated by GNU Autoconf 2.69,
   with options \\"\$ac_cs_config\\"
 
diff -pruN 0.15+dfsg-1/configure.ac 0.15.1+dfsg-1/configure.ac
--- 0.15+dfsg-1/configure.ac	2020-09-03 11:43:25.000000000 +0000
+++ 0.15.1+dfsg-1/configure.ac	2020-10-22 10:44:51.000000000 +0000
@@ -39,6 +39,9 @@ AS_IF([test "x$enable_caps" != "xno"], [
 	])
 ])
 
+dnl include support for libkrun (EXPERIMENTAL)
+AC_ARG_WITH([libkrun], AS_HELP_STRING([--with-libkrun], [build with libkrun support]))
+AS_IF([test "x$with_libkrun" = "xyes"], AC_CHECK_HEADERS([libkrun.h], AC_DEFINE([HAVE_LIBKRUN], 1, [Define if libkrun is available]), [AC_MSG_ERROR([*** Missing libkrun headers])]))
 dnl libseccomp
 AC_ARG_ENABLE([seccomp],
 	AS_HELP_STRING([--disable-seccomp], [Ignore libseccomp and disable support]))
diff -pruN 0.15+dfsg-1/crun.1 0.15.1+dfsg-1/crun.1
--- 0.15+dfsg-1/crun.1	2020-09-22 18:31:13.000000000 +0000
+++ 0.15.1+dfsg-1/crun.1	2020-10-22 10:44:51.000000000 +0000
@@ -386,7 +386,9 @@ it is supported in the OCI runtime specs
 .PP
 If the annotation \fB\fCrun.oci.seccomp.plugins=PLUGIN1[:PLUGIN2]...\fR is specified, the
 seccomp listener fd is handled through the specified plugins.  The
-plugin must either be an absolute path or a filename.
+plugin must either be an absolute path or a file name that is looked
+up by \fB\fCldopen(3)\fR\&.  More information on how the lookup is performed
+are available on the \fB\fCld.so(8)\fR man page.
 
 .SH \fB\fCrun.oci.seccomp\_fail\_unknown\_syscall=1\fR
 .PP
@@ -460,6 +462,16 @@ will open the specified file and use it
 processes.  The file is opened in append mode and it is created if it
 doesn't already exist.
 
+.SH \fB\fCrun.oci.handler=HANDLER\fR
+.PP
+It is an experimental feature.
+
+.PP
+If specified, run the specified handler for execing the container.
+The only supported value is \fB\fCkrun\fR\&.  When \fB\fCkrun\fR is specified, the
+\fB\fClibkrun.so\fR shared object is loaded and it is used to launch the
+container using libkrun.
+
 .SH tmpcopyup mount options
 .PP
 If the \fB\fCtmpcopyup\fR option is specified for a tmpfs, then the path that
@@ -491,7 +503,11 @@ allbox;
 l l l l 
 l l l l .
 \fB\fCOCI (x)\fR	\fB\fCcgroup 2 value (y)\fR	\fB\fCconversion\fR	\fB\fCcomment\fR
-limit	memory.max	y = x	swap	memory.swap\_max	y = x	reservation	memory.low	y = x	.TE
+limit	memory.max	y = x	swap	memory.swap.max	y = x \- memory\_limit	T{
+the swap limit on cgroup v1 includes the memory usage too
+T}
+reservation	memory.low	y = x	
+.TE
 
 .SH PIDs controller
 .TS
@@ -499,7 +515,8 @@ allbox;
 l l l l 
 l l l l .
 \fB\fCOCI (x)\fR	\fB\fCcgroup 2 value (y)\fR	\fB\fCconversion\fR	\fB\fCcomment\fR
-limit	pids.max	y = x	.TE
+limit	pids.max	y = x	
+.TE
 
 .SH CPU controller
 .TS
@@ -519,6 +536,7 @@ T}
 quota	cpu.max	y = x	T{
 period and quota are written together
 T}
+
 .TE
 
 .SH blkio controller
@@ -539,7 +557,8 @@ T}
 	T{
 convert linearly from [10\-1000] to [1\-10000]
 T}
-rbps	io.max	y=x	wbps	io.max	y=x	riops	io.max	y=x	wiops	io.max	y=x	.TE
+rbps	io.max	y=x	wbps	io.max	y=x	riops	io.max	y=x	wiops	io.max	y=x	
+.TE
 
 .SH cpuset controller
 .TS
@@ -547,7 +566,8 @@ allbox;
 l l l l 
 l l l l .
 \fB\fCOCI (x)\fR	\fB\fCcgroup 2 value (y)\fR	\fB\fCconversion\fR	\fB\fCcomment\fR
-cpus	cpuset.cpus	y = x	mems	cpuset.mems	y = x	.TE
+cpus	cpuset.cpus	y = x	mems	cpuset.mems	y = x	
+.TE
 
 .SH hugetlb controller
 .TS
@@ -555,4 +575,5 @@ allbox;
 l l l l 
 l l l l .
 \fB\fCOCI (x)\fR	\fB\fCcgroup 2 value (y)\fR	\fB\fCconversion\fR	\fB\fCcomment\fR
-\&.limit\_\&in\_\&bytes	hugetlb.\&.max	y = x	.TE
+\&.limit\_\&in\_\&bytes	hugetlb.\&.max	y = x	
+.TE
diff -pruN 0.15+dfsg-1/crun.1.md 0.15.1+dfsg-1/crun.1.md
--- 0.15+dfsg-1/crun.1.md	2020-09-03 11:43:25.000000000 +0000
+++ 0.15.1+dfsg-1/crun.1.md	2020-10-22 10:44:51.000000000 +0000
@@ -369,6 +369,14 @@ will open the specified file and use it
 processes.  The file is opened in append mode and it is created if it
 doesn't already exist.
 
+## `run.oci.handler=HANDLER`
+
+It is an experimental feature.
+
+If specified, run the specified handler for execing the container.
+The only supported value is `krun`.  When `krun` is specified, the
+`libkrun.so` shared object is loaded and it is used to launch the
+container using libkrun.
 
 ## tmpcopyup mount options
 
@@ -398,7 +406,7 @@ they are converted when needed from the
 | OCI (x) | cgroup 2 value (y) | conversion  |   comment |
 |---|---|---|---|
 | limit | memory.max | y = x ||
-| swap | memory.swap_max | y = x ||
+| swap | memory.swap.max | y = x - memory_limit | the swap limit on cgroup v1 includes the memory usage too |
 | reservation | memory.low | y = x ||
 
 ## PIDs controller
diff -pruN 0.15+dfsg-1/debian/changelog 0.15.1+dfsg-1/debian/changelog
--- 0.15+dfsg-1/debian/changelog	2020-09-23 20:44:34.000000000 +0000
+++ 0.15.1+dfsg-1/debian/changelog	2020-11-19 11:32:23.000000000 +0000
@@ -1,3 +1,9 @@
+crun (0.15.1+dfsg-1) unstable; urgency=medium
+
+  * New upstream release.
+
+ -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 19 Nov 2020 22:32:23 +1100
+
 crun (0.15+dfsg-1) unstable; urgency=medium
 
   * New upstream release.
diff -pruN 0.15+dfsg-1/git-version.h 0.15.1+dfsg-1/git-version.h
--- 0.15+dfsg-1/git-version.h	2020-09-23 14:49:11.000000000 +0000
+++ 0.15.1+dfsg-1/git-version.h	2020-11-03 15:18:31.000000000 +0000
@@ -1,4 +1,4 @@
 /* autogenerated.  */
 #ifndef GIT_VERSION
-# define GIT_VERSION "56ca95e61639510c7dbd39ff512f80f626404969"
+# define GIT_VERSION "eb0145e5ad4d8207e84a327248af76663d4e50dd"
 #endif
diff -pruN 0.15+dfsg-1/NEWS 0.15.1+dfsg-1/NEWS
--- 0.15+dfsg-1/NEWS	2020-09-23 14:47:06.000000000 +0000
+++ 0.15.1+dfsg-1/NEWS	2020-11-03 15:17:33.000000000 +0000
@@ -1,3 +1,18 @@
+* crun-0.15.1
+
+- add experimental support for libkrun.
+- fix check for pidfd availability on older kernels.
+- linux: do not set data when remounting read-only.  Fix 'ro' mounts
+  on older kernels when SELinux is enabled.
+- linux: label the cgroup v1 tmpfs when SELinux is enabled.
+- container: truncate the pid file before writing to it.
+- exec: fix check for read bytes from the sync socket.
+- check the process has a cgroup before allowing pause and resume.
+- linux: always create a user namespace if not running with euid == 0.
+- libcrun can use a hook instead of executing a container process.
+- use libyajl to generate hooks json input.
+- handle correctly ENOENT for seccomp notifications.
+
 * crun-0.15
 
 - add support for OCI unified cgroup v2.
diff -pruN 0.15+dfsg-1/README.md 0.15.1+dfsg-1/README.md
--- 0.15+dfsg-1/README.md	2020-09-03 20:51:17.000000000 +0000
+++ 0.15.1+dfsg-1/README.md	2020-10-22 10:44:51.000000000 +0000
@@ -41,7 +41,7 @@ containers, the containers run `/bin/tru
 crun requires fewer resources, so it is also possible to set stricter
 limits on the memory and number of PIDs allowed in the container:
 
-``` shell
+```console
 # podman --runtime /usr/bin/runc run --rm --pids-limit 1 fedora echo it works
 Error: container_linux.go:346: starting container process caused "process_linux.go:319: getting the final child's pid from pipe caused \"EOF\"": OCI runtime error
 
@@ -64,43 +64,44 @@ These dependencies are required for the
 
 ### Fedora
 
-``` shell
-dnf install -y make python git gcc automake autoconf libcap-devel \
+```console
+$ sudo dnf install -y make python git gcc automake autoconf libcap-devel \
     systemd-devel yajl-devel libseccomp-devel \
     go-md2man glibc-static python3-libmount libtool
 ```
 
 ### RHEL/CentOS 8
 
-``` shell
-yum --enablerepo='*' install -y make automake autoconf gettext \
+```console
+$ sudo yum --enablerepo='*' install -y make automake autoconf gettext \
     libtool gcc libcap-devel systemd-devel yajl-devel \
-    libseccomp-devel python36 libtool
+    libseccomp-devel python36
 ```
 
 go-md2man is not available on RHEL/CentOS 8, so if you'd like to build
 the man page, you also need to manually install go-md2man. It can be
 installed with:
 
-``` shell
-yum --enablerepo='*' install -y golang
-export GOPATH=$HOME/go
-go get github.com/cpuguy83/go-md2man
-export PATH=$PATH:$GOPATH/bin
+```console
+$ sudo yum --enablerepo='*' install -y golang
+$ export GOPATH=$HOME/go
+$ go get github.com/cpuguy83/go-md2man
+$ export PATH=$PATH:$GOPATH/bin
 ```
 
 ### Ubuntu
 
-``` shell
-apt-get install -y make git gcc build-essential pkgconf libtool \
+```console
+$ sudo apt-get update
+$ sudo apt-get install -y make git gcc build-essential pkgconf libtool \
    libsystemd-dev libcap-dev libseccomp-dev libyajl-dev \
    go-md2man libtool autoconf python3 automake
 ```
 
 ### Alpine
 
-``` shell
-apk add gcc automake autoconf libtool gettext pkgconf git make musl-dev \
+```console
+# apk add gcc automake autoconf libtool gettext pkgconf git make musl-dev \
     python3 libcap-dev libseccomp-dev yajl-dev argp-standalone go-md2man
 ```
 
@@ -112,16 +113,16 @@ afterwards.
 
 Once all the dependencies are installed:
 
-``` shell
-./autogen.sh
-./configure
-make
+```console
+$ ./autogen.sh
+$ ./configure
+$ make
 ```
 
 To install into default PREFIX (`/usr/local`):
 
-``` shell
-sudo make install
+```console
+$ sudo make install
 ```
 
 ### Shared Libraries
@@ -141,8 +142,8 @@ stripped ELF binary for [glibc](https://
 
 To build the binaries by locally installing the nix package manager:
 
-``` shell
-nix build -f nix/
+```console
+$ nix build -f nix/
 ```
 
 ### Ansible
@@ -151,13 +152,13 @@ An [Ansible Role](https://github.com/alv
 also available to automate the installation of the above statically
 linked binary on its supported OS:
 
-``` shell
-sudo su -
-mkdir -p ~/.ansible/roles
-cd ~/.ansible/roles
-git clone https://github.com/alvistack/ansible-role-crun.git crun
-cd ~/.ansible/roles/crun
-pip3 install --upgrade --ignore-installed --requirement requirements.txt
-molecule converge
-molecule verify
+```console
+$ sudo su -
+# mkdir -p ~/.ansible/roles
+# cd ~/.ansible/roles
+# git clone https://github.com/alvistack/ansible-role-crun.git crun
+# cd ~/.ansible/roles/crun
+# pip3 install --upgrade --ignore-installed --requirement requirements.txt
+# molecule converge
+# molecule verify
 ```
diff -pruN 0.15+dfsg-1/src/create.c 0.15.1+dfsg-1/src/create.c
--- 0.15+dfsg-1/src/create.c	2020-09-03 11:43:25.000000000 +0000
+++ 0.15.1+dfsg-1/src/create.c	2020-10-22 10:44:51.000000000 +0000
@@ -47,7 +47,7 @@ static struct argp_option options[]
         { "config", 'f', "FILE", 0, "override the config file name", 0 },
         { "console-socket", OPTION_CONSOLE_SOCKET, "SOCK", 0,
           "path to a socket that will receive the ptmx end of the tty", 0 },
-        { "preserve-fds", OPTION_PRESERVE_FDS, 0, 0, "pass additional FDs to the container", 0 },
+        { "preserve-fds", OPTION_PRESERVE_FDS, "N", 0, "pass additional FDs to the container", 0 },
         { "no-pivot", OPTION_NO_PIVOT, 0, 0, "do not use pivot_root", 0 },
         { "pid-file", OPTION_PID_FILE, "FILE", 0, "where to write the PID of the container", 0 },
         { "no-subreaper", OPTION_NO_SUBREAPER, 0, 0, "do not create a subreaper process", 0 },
diff -pruN 0.15+dfsg-1/src/exec.c 0.15.1+dfsg-1/src/exec.c
--- 0.15+dfsg-1/src/exec.c	2020-09-03 11:43:25.000000000 +0000
+++ 0.15.1+dfsg-1/src/exec.c	2020-10-22 10:44:51.000000000 +0000
@@ -68,7 +68,7 @@ static struct argp_option options[]
         { "env", 'e', "ENV", 0, "add an environment variable", 0 },
         { "cap", 'c', "CAP", 0, "add a capability", 0 },
         { "pid-file", OPTION_PID_FILE, "FILE", 0, "where to write the PID of the container", 0 },
-        { "preserve-fds", OPTION_PRESERVE_FDS, 0, 0, "pass additional FDs to the container", 0 },
+        { "preserve-fds", OPTION_PRESERVE_FDS, "N", 0, "pass additional FDs to the container", 0 },
         {
             0,
         } };
diff -pruN 0.15+dfsg-1/src/libcrun/cgroup.c 0.15.1+dfsg-1/src/libcrun/cgroup.c
--- 0.15+dfsg-1/src/libcrun/cgroup.c	2020-09-22 18:17:19.000000000 +0000
+++ 0.15.1+dfsg-1/src/libcrun/cgroup.c	2020-10-22 10:44:51.000000000 +0000
@@ -374,6 +374,75 @@ initialize_cpuset_subsystem_rec (char *p
 }
 
 static int
+check_cgroup_v2_controller_available_wrapper (int ret, int cgroup_dirfd, const char *name, libcrun_error_t *err)
+{
+  if (ret == 0 || err == NULL)
+    return 0;
+
+  errno = crun_error_get_errno (err);
+
+  /* If the file is not found, try to give a more meaningful error message.  */
+  if (errno == ENOENT || errno == EPERM || errno == EACCES)
+    {
+      cleanup_free char *controllers = NULL;
+      libcrun_error_t tmp_err = NULL;
+      cleanup_free char *key = NULL;
+      char *saveptr = NULL;
+      bool found = false;
+      const char *token;
+      char *it;
+
+      /* Check if the specified controller is enabled.  */
+      key = xstrdup (name);
+
+      it = strchr (key, '.');
+      if (it == NULL)
+        {
+          crun_error_release (err);
+          return crun_make_error (err, 0, "the specified key has not the form CONTROLLER.VALUE `%s`",
+                                  name);
+        }
+      *it = '\0';
+
+      /* cgroup. files are not part of a controller.  Return the original error.  */
+      if (strcmp (key, "cgroup") == 0)
+        return ret;
+
+      /* If the cgroup.controllers file cannot be read, return the original error.  */
+      if (read_all_file_at (cgroup_dirfd, "cgroup.controllers", &controllers, NULL, &tmp_err) < 0)
+        {
+          crun_error_release (&tmp_err);
+          return ret;
+        }
+      for (token = strtok_r (controllers, " \n", &saveptr); token; token = strtok_r (NULL, " \n", &saveptr))
+        {
+          if (strcmp (token, key) == 0)
+            {
+              found = true;
+              break;
+            }
+        }
+      if (! found)
+        {
+          crun_error_release (err);
+          return crun_make_error (err, 0, "the requested cgroup controller `%s` is not available", key);
+        }
+    }
+  return ret;
+}
+
+static int
+write_file_and_check_controllers_at (bool cgroup2, int dirfd, const char *name, const void *data, size_t len, libcrun_error_t *err)
+{
+  int ret;
+
+  ret = write_file_at (dirfd, name, data, len, err);
+  if (cgroup2)
+    return check_cgroup_v2_controller_available_wrapper (ret, dirfd, name, err);
+  return ret;
+}
+
+static int
 initialize_cpuset_subsystem (const char *path, libcrun_error_t *err)
 {
   cleanup_free char *tmp_path = xstrdup (path);
@@ -1520,6 +1589,9 @@ libcrun_cgroup_pause_unpause_with_mode (
   const char *state = "";
   int ret;
 
+  if (cgroup_path == NULL || cgroup_path[0] == '\0')
+    return crun_make_error (err, 0, "cannot %s the container without a cgroup", pause ? "pause" : "resume");
+
   if (cgroup_mode == CGROUP_MODE_UNIFIED)
     {
       state = pause ? "1" : "0";
@@ -1993,10 +2065,14 @@ write_blkio_resources (int dirfd, bool c
   if (cgroup2)
     {
       cleanup_close int wfd = -1;
+      const char *name = "io.max";
 
-      wfd = openat (dirfd, "io.max", O_WRONLY);
+      wfd = openat (dirfd, name, O_WRONLY);
       if (UNLIKELY (wfd < 0))
-        return crun_make_error (err, errno, "open io.max");
+        {
+          ret = crun_make_error (err, errno, "open `%s`", name);
+          return check_cgroup_v2_controller_available_wrapper (ret, dirfd, name, err);
+        }
 
       ret = write_blkio_v2_resources_throttling (wfd, "rbps", (throttling_s **) blkio->throttle_read_bps_device,
                                                  blkio->throttle_read_bps_device_len, err);
@@ -2100,7 +2176,7 @@ write_hugetlb_resources (int dirfd, bool
       xasprintf (&filename, "hugetlb.%s.%s", htlb[i]->page_size, suffix);
 
       len = sprintf (fmt_buf, "%lu", htlb[i]->limit);
-      ret = write_file_at (dirfd, filename, fmt_buf, len, err);
+      ret = write_file_and_check_controllers_at (cgroup2, dirfd, filename, fmt_buf, len, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -2333,8 +2409,7 @@ write_memory_swap (int dirfd, bool cgrou
 
   swap_buf_len = cg_itoa (swap_buf, swap, cgroup2);
 
-  return write_file_at (dirfd, cgroup2 ? "memory.swap.max" : "memory.memsw.limit_in_bytes", swap_buf, swap_buf_len,
-                        err);
+  return write_file_and_check_controllers_at (cgroup2, dirfd, cgroup2 ? "memory.swap.max" : "memory.memsw.limit_in_bytes", swap_buf, swap_buf_len, err);
 }
 
 static int
@@ -2391,7 +2466,7 @@ write_memory_resources (int dirfd, bool
   if (memory->reservation_present)
     {
       len = sprintf (fmt_buf, "%lu", memory->reservation);
-      ret = write_file_at (dirfd, cgroup2 ? "memory.low" : "memory.soft_limit_in_bytes", fmt_buf, len, err);
+      ret = write_file_and_check_controllers_at (cgroup2, dirfd, cgroup2 ? "memory.low" : "memory.soft_limit_in_bytes", fmt_buf, len, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -2439,7 +2514,7 @@ write_pids_resources (int dirfd, bool cg
       int ret;
 
       len = cg_itoa (fmt_buf, pids->limit, cgroup2);
-      ret = write_file_at (dirfd, "pids.max", fmt_buf, len, err);
+      ret = write_file_and_check_controllers_at (cgroup2, dirfd, "pids.max", fmt_buf, len, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -2469,7 +2544,7 @@ write_cpu_resources (int dirfd_cpu, bool
 
       len = sprintf (fmt_buf, "%u", val);
 
-      ret = write_file_at (dirfd_cpu, cgroup2 ? "cpu.weight" : "cpu.shares", fmt_buf, len, err);
+      ret = write_file_and_check_controllers_at (cgroup2, dirfd_cpu, cgroup2 ? "cpu.weight" : "cpu.shares", fmt_buf, len, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -2524,7 +2599,7 @@ write_cpu_resources (int dirfd_cpu, bool
         len = sprintf (fmt_buf, "max %" PRIi64, period);
       else
         len = sprintf (fmt_buf, "%" PRIi64 " %" PRIi64, quota, period);
-      ret = write_file_at (dirfd_cpu, "cpu.max", fmt_buf, len, err);
+      ret = write_file_and_check_controllers_at (cgroup2, dirfd_cpu, "cpu.max", fmt_buf, len, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -2532,20 +2607,20 @@ write_cpu_resources (int dirfd_cpu, bool
 }
 
 static int
-write_cpuset_resources (int dirfd_cpuset, int cgroup2 arg_unused, runtime_spec_schema_config_linux_resources_cpu *cpu,
+write_cpuset_resources (int dirfd_cpuset, int cgroup2, runtime_spec_schema_config_linux_resources_cpu *cpu,
                         libcrun_error_t *err)
 {
   int ret;
 
   if (cpu->cpus)
     {
-      ret = write_file_at (dirfd_cpuset, "cpuset.cpus", cpu->cpus, strlen (cpu->cpus), err);
+      ret = write_file_and_check_controllers_at (cgroup2, dirfd_cpuset, "cpuset.cpus", cpu->cpus, strlen (cpu->cpus), err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
   if (cpu->mems)
     {
-      ret = write_file_at (dirfd_cpuset, "cpuset.mems", cpu->mems, strlen (cpu->mems), err);
+      ret = write_file_and_check_controllers_at (cgroup2, dirfd_cpuset, "cpuset.mems", cpu->mems, strlen (cpu->mems), err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -2705,60 +2780,9 @@ write_unified_resources (int cgroup_dirf
         return crun_make_error (err, 0, "key `%s` must be a file name without any slash", resources->unified->keys[i]);
 
       len = strlen (resources->unified->values[i]);
-      ret = write_file_at (cgroup_dirfd, resources->unified->keys[i], resources->unified->values[i], len, err);
+      ret = write_file_and_check_controllers_at (true, cgroup_dirfd, resources->unified->keys[i], resources->unified->values[i], len, err);
       if (UNLIKELY (ret < 0))
-        {
-          errno = crun_error_get_errno (err);
-
-          /* If the file is not found, try to give a more meaningful error message.  */
-          if (errno == ENOENT || errno == EPERM || errno == EACCES)
-            {
-              cleanup_free char *controllers = NULL;
-              libcrun_error_t tmp_err = NULL;
-              cleanup_free char *key = NULL;
-              char *saveptr = NULL;
-              bool found = false;
-              const char *token;
-              char *it;
-
-              /* Check if the specified controller is enabled.  */
-              key = xstrdup (resources->unified->keys[i]);
-
-              it = strchr (key, '.');
-              if (it == NULL)
-                {
-                  crun_error_release (err);
-                  return crun_make_error (err, 0, "the specified key has not the form CONTROLLER.VALUE `%s`",
-                                          resources->unified->keys[i]);
-                }
-              *it = '\0';
-
-              /* cgroup. files are not part of a controller.  Return the original error.  */
-              if (strcmp (key, "cgroup") == 0)
-                return ret;
-
-              /* If the cgroup.controllers file cannot be read, return the original error.  */
-              if (read_all_file_at (cgroup_dirfd, "cgroup.controllers", &controllers, NULL, &tmp_err) < 0)
-                {
-                  crun_error_release (&tmp_err);
-                  return ret;
-                }
-              for (token = strtok_r (controllers, " \n", &saveptr); token; token = strtok_r (NULL, " \n", &saveptr))
-                {
-                  if (strcmp (token, key) == 0)
-                    {
-                      found = true;
-                      break;
-                    }
-                }
-              if (! found)
-                {
-                  crun_error_release (err);
-                  return crun_make_error (err, 0, "the requested controller `%s` is not available", key);
-                }
-            }
-          return ret;
-        }
+        return ret;
     }
 
   return 0;
diff -pruN 0.15+dfsg-1/src/libcrun/container.c 0.15.1+dfsg-1/src/libcrun/container.c
--- 0.15+dfsg-1/src/libcrun/container.c	2020-09-22 18:17:19.000000000 +0000
+++ 0.15.1+dfsg-1/src/libcrun/container.c	2020-11-02 15:37:17.000000000 +0000
@@ -47,6 +47,10 @@
 #  include <dlfcn.h>
 #endif
 
+#ifdef HAVE_LIBKRUN
+#  include <libkrun.h>
+#endif
+
 #ifdef HAVE_SYSTEMD
 #  include <systemd/sd-daemon.h>
 #endif
@@ -79,6 +83,11 @@ struct container_entrypoint_s
 
   int hooks_out_fd;
   int hooks_err_fd;
+
+  /* If specified, it is called instead of
+     execve.  */
+  int (*exec_func) (void *container, void *arg, const char *pathname, char *const argv[]);
+  void *exec_func_arg;
 };
 
 struct sync_socket_message_s
@@ -503,8 +512,7 @@ do_hooks (runtime_spec_schema_config_sch
 {
   size_t i, stdin_len;
   int ret;
-  cleanup_free char *stdin = NULL;
-  const unsigned char *annotations = (const unsigned char *) "{}";
+  char *stdin = NULL;
   cleanup_free char *cwd_allocated = NULL;
   const char *rootfs = def->root ? def->root->path : "";
   yajl_gen gen = NULL;
@@ -516,14 +524,32 @@ do_hooks (runtime_spec_schema_config_sch
         OOM ();
     }
 
-  if (def && def->annotations && def->annotations->len)
-    {
-      size_t len;
+  gen = yajl_gen_alloc (NULL);
+  if (gen == NULL)
+    return crun_make_error (err, 0, "yajl_gen_alloc failed");
 
-      gen = yajl_gen_alloc (NULL);
-      if (gen == NULL)
-        return crun_make_error (err, 0, "yajl_gen_alloc failed");
+  yajl_gen_map_open (gen);
+  yajl_gen_string (gen, YAJL_STR ("ociVersion"), strlen ("ociVersion"));
+  yajl_gen_string (gen, YAJL_STR ("1.0"), strlen ("1.0"));
 
+  yajl_gen_string (gen, YAJL_STR ("id"), strlen ("id"));
+  yajl_gen_string (gen, YAJL_STR (id), strlen (id));
+
+  yajl_gen_string (gen, YAJL_STR ("pid"), strlen ("pid"));
+  yajl_gen_integer (gen, pid);
+
+  yajl_gen_string (gen, YAJL_STR ("root"), strlen ("root"));
+  yajl_gen_string (gen, YAJL_STR (rootfs), strlen (rootfs));
+
+  yajl_gen_string (gen, YAJL_STR ("bundle"), strlen ("bundle"));
+  yajl_gen_string (gen, YAJL_STR (cwd), strlen (cwd));
+
+  yajl_gen_string (gen, YAJL_STR ("status"), strlen ("status"));
+  yajl_gen_string (gen, YAJL_STR (status), strlen (status));
+
+  if (def && def->annotations && def->annotations->len)
+    {
+      yajl_gen_string (gen, YAJL_STR ("annotations"), strlen ("annotations"));
       yajl_gen_map_open (gen);
       for (i = 0; i < def->annotations->len; i++)
         {
@@ -534,14 +560,11 @@ do_hooks (runtime_spec_schema_config_sch
           yajl_gen_string (gen, YAJL_STR (val), strlen (val));
         }
       yajl_gen_map_close (gen);
-
-      yajl_gen_get_buf (gen, &annotations, &len);
     }
 
-  stdin_len = xasprintf (&stdin,
-                         "{\"ociVersion\":\"1.0\", \"id\":\"%s\", \"pid\":%i, \"root\":\"%s\", \"bundle\":\"%s\", "
-                         "\"status\":\"%s\", \"annotations\":%s}",
-                         id, pid, rootfs, cwd, status, annotations);
+  yajl_gen_map_close (gen);
+
+  yajl_gen_get_buf (gen, (const unsigned char **) &stdin, &stdin_len);
 
   ret = 0;
 
@@ -567,6 +590,105 @@ do_hooks (runtime_spec_schema_config_sch
   return ret;
 }
 
+#if HAVE_DLOPEN && HAVE_LIBKRUN
+static int
+libkrun_do_exec (void *container, void *arg, const char *pathname, char *const argv[])
+{
+  runtime_spec_schema_config_schema *def = ((libcrun_container_t *) container)->container_def;
+  int32_t (*krun_create_ctx) ();
+  int (*krun_start_enter) (uint32_t ctx_id);
+  int32_t (*krun_set_vm_config) (uint32_t ctx_id, uint8_t num_vcpus, uint32_t ram_mib);
+  int32_t (*krun_set_root) (uint32_t ctx_id, const char *root_path);
+  int32_t (*krun_set_exec) (uint32_t ctx_id, const char *exec_path, char *const argv[], char *const envp[]);
+  void *handle = arg;
+  uint32_t num_vcpus, ram_mib;
+  int32_t ctx_id, ret;
+  cpu_set_t set;
+
+  krun_create_ctx = dlsym (handle, "krun_create_ctx");
+  krun_start_enter = dlsym (handle, "krun_start_enter");
+  krun_set_vm_config = dlsym (handle, "krun_set_vm_config");
+  krun_set_root = dlsym (handle, "krun_set_root");
+  krun_set_exec = dlsym (handle, "krun_set_exec");
+  if (krun_create_ctx == NULL || krun_start_enter == NULL || krun_set_vm_config == NULL || krun_set_root == NULL
+      || krun_set_exec == NULL)
+    {
+      fprintf (stderr, "could not find symbol in `libkrun.so`");
+      dlclose (handle);
+      return -1;
+    }
+
+  /* If sched_getaffinity fails, default to 1 vcpu.  */
+  num_vcpus = 1;
+  /* If no memory limit is specified, default to 2G.  */
+  ram_mib = 2 * 1024;
+
+  if (def && def->linux && def->linux->resources && def->linux->resources->memory
+      && def->linux->resources->memory->limit_present)
+    ram_mib = def->linux->resources->memory->limit / (1024 * 1024);
+
+  CPU_ZERO (&set);
+  if (sched_getaffinity (getpid (), sizeof (set), &set) == 0)
+    num_vcpus = CPU_COUNT (&set);
+
+  ctx_id = krun_create_ctx ();
+  if (UNLIKELY (ctx_id < 0))
+    error (EXIT_FAILURE, -ret, "could not create krun context");
+
+  ret = krun_set_vm_config (ctx_id, num_vcpus, ram_mib);
+  if (UNLIKELY (ret < 0))
+    error (EXIT_FAILURE, -ret, "could not set krun vm configuration");
+
+  ret = krun_set_root (ctx_id, "/");
+  if (UNLIKELY (ret < 0))
+    error (EXIT_FAILURE, -ret, "could not set krun root");
+
+  ret = krun_set_exec (ctx_id, pathname, &argv[1], NULL);
+  if (UNLIKELY (ret < 0))
+    error (EXIT_FAILURE, -ret, "could not set krun executable");
+
+  return krun_start_enter (ctx_id);
+}
+#endif
+
+static int
+libcrun_configure_libkrun (struct container_entrypoint_s *args, libcrun_error_t *err)
+{
+#if HAVE_DLOPEN && HAVE_LIBKRUN
+  void *handle;
+#endif
+
+#if HAVE_DLOPEN && HAVE_LIBKRUN
+  handle = dlopen ("libkrun.so", RTLD_NOW);
+  if (handle == NULL)
+    return crun_make_error (err, 0, "could not load `libkrun.so`: %s", dlerror ());
+
+  args->exec_func = libkrun_do_exec;
+  args->exec_func_arg = handle;
+
+  return 0;
+#else
+  (void) args;
+  return crun_make_error (err, ENOTSUP, "libkrun or dlopen not present");
+#endif
+}
+
+static int
+libcrun_configure_handler (struct container_entrypoint_s *args, libcrun_error_t *err)
+{
+  const char *annotation;
+
+  annotation = find_annotation (args->container, "run.oci.handler");
+  /*Nothing to do.  */
+  if (annotation == NULL)
+    return 0;
+
+  if (strcmp (annotation, "krun") == 0)
+    return libcrun_configure_libkrun (args, err);
+
+  return crun_make_error (err, EINVAL, "invalid handler specified `%s`", annotation);
+}
+
 /* Initialize the environment where the container process runs.
    It is used by the container init process.  */
 static int
@@ -583,6 +705,10 @@ container_init_setup (void *args, char *
   cleanup_free char *rootfs = NULL;
   int no_new_privs;
 
+  ret = libcrun_configure_handler (args, err);
+  if (UNLIKELY (ret < 0))
+    return ret;
+
   ret = initialize_security (def->process, err);
   if (UNLIKELY (ret < 0))
     return ret;
@@ -591,11 +717,14 @@ container_init_setup (void *args, char *
   if (UNLIKELY (ret < 0))
     return ret;
 
-  rootfs = realpath (def->root->path, NULL);
-  if (UNLIKELY (rootfs == NULL))
+  if (def->root && def->root->path)
     {
-      /* If realpath failed for any reason, try the relative directory.  */
-      rootfs = xstrdup (def->root->path);
+      rootfs = realpath (def->root->path, NULL);
+      if (UNLIKELY (rootfs == NULL))
+        {
+          /* If realpath failed for any reason, try the relative directory.  */
+          rootfs = xstrdup (def->root->path);
+        }
     }
 
   if (entrypoint_args->terminal_socketpair[0] >= 0)
@@ -655,9 +784,12 @@ container_init_setup (void *args, char *
   if (UNLIKELY (ret < 0))
     crun_error_write_warning_and_release (entrypoint_args->context->output_handler_arg, &err);
 
-  ret = libcrun_do_pivot_root (container, entrypoint_args->context->no_pivot, rootfs, err);
-  if (UNLIKELY (ret < 0))
-    return ret;
+  if (rootfs)
+    {
+      ret = libcrun_do_pivot_root (container, entrypoint_args->context->no_pivot, rootfs, err);
+      if (UNLIKELY (ret < 0))
+        return ret;
+    }
 
   ret = libcrun_reopen_dev_null (err);
   if (UNLIKELY (ret < 0))
@@ -913,6 +1045,13 @@ container_init (void *args, char *notify
       (void) lseek (2, 0, SEEK_END);
     }
 
+  if (entrypoint_args->exec_func)
+    {
+      ret = entrypoint_args->exec_func (entrypoint_args->container, entrypoint_args->exec_func_arg, exec_path,
+                                        def->process->args);
+      _exit (ret);
+    }
+
   execv (exec_path, def->process->args);
 
   if (errno == ENOENT)
@@ -1135,10 +1274,11 @@ write_container_status (libcrun_containe
 {
   cleanup_free char *cwd = get_current_dir_name ();
   char *external_descriptors = libcrun_get_external_descriptors (container);
+  char *rootfs = container->container_def->root ? container->container_def->root->path : "";
   libcrun_container_status_t status = { .pid = pid,
                                         .cgroup_path = cgroup_path,
                                         .scope = scope,
-                                        .rootfs = container->container_def->root->path,
+                                        .rootfs = rootfs,
                                         .bundle = cwd,
                                         .created = created,
                                         .systemd_cgroup = context->systemd_cgroup,
@@ -1230,7 +1370,7 @@ wait_for_process (pid_t pid, libcrun_con
     {
       char buf[12];
       size_t buf_len = sprintf (buf, "%d", pid);
-      ret = write_file (context->pid_file, buf, buf_len, err);
+      ret = write_file_with_flags (context->pid_file, O_CREAT | O_TRUNC, buf, buf_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
@@ -1280,6 +1420,10 @@ wait_for_process (pid_t pid, libcrun_con
       conf.bundle_path = context->bundle;
       conf.oci_config_path = oci_config_path;
 
+      ret = set_blocking_fd (seccomp_notify_fd, 0, err);
+      if (UNLIKELY (ret < 0))
+        return ret;
+
       ret = libcrun_load_seccomp_notify_plugins (&seccomp_notify_ctx, seccomp_notify_plugins, &conf, err);
       if (UNLIKELY (ret < 0))
         return ret;
@@ -1598,6 +1742,8 @@ libcrun_container_run_internal (libcrun_
     .hooks_out_fd = -1,
     .hooks_err_fd = -1,
     .seccomp_receiver_fd = -1,
+    .exec_func = context->exec_func,
+    .exec_func_arg = context->exec_func_arg,
   };
 
   if (def->hooks
@@ -1832,14 +1978,17 @@ libcrun_container_run_internal (libcrun_
 }
 
 static int
-check_config_file (runtime_spec_schema_config_schema *def, libcrun_error_t *err)
+check_config_file (runtime_spec_schema_config_schema *def, libcrun_context_t *context, libcrun_error_t *err)
 {
-  if (UNLIKELY (def->root == NULL))
-    return crun_make_error (err, 0, "invalid config file, no 'root' block specified");
   if (UNLIKELY (def->linux == NULL))
     return crun_make_error (err, 0, "invalid config file, no 'linux' block specified");
-  if (UNLIKELY (def->mounts == NULL))
-    return crun_make_error (err, 0, "invalid config file, no 'mounts' block specified");
+  if (context->exec_func == NULL)
+    {
+      if (UNLIKELY (def->root == NULL))
+        return crun_make_error (err, 0, "invalid config file, no 'root' block specified");
+      if (UNLIKELY (def->mounts == NULL))
+        return crun_make_error (err, 0, "invalid config file, no 'mounts' block specified");
+    }
   return 0;
 }
 
@@ -1890,7 +2039,7 @@ libcrun_container_run (libcrun_context_t
 
   container->context = context;
 
-  ret = check_config_file (def, err);
+  ret = check_config_file (def, context, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
@@ -1992,7 +2141,7 @@ libcrun_container_create (libcrun_contex
   if (def->oci_version && strstr (def->oci_version, "1.0") == NULL)
     return crun_make_error (err, 0, "unknown version specified");
 
-  ret = check_config_file (def, err);
+  ret = check_config_file (def, context, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
@@ -2595,10 +2744,10 @@ libcrun_container_exec (libcrun_context_
         }
     }
 
-  TEMP_FAILURE_RETRY (read (pipefd0, &b, sizeof (b)));
+  ret = TEMP_FAILURE_RETRY (read (pipefd0, &b, sizeof (b)));
   TEMP_FAILURE_RETRY (close (pipefd0));
   pipefd0 = -1;
-  if (b != '0')
+  if (ret != 1 || b != '0')
     ret = -1;
   else
     {
@@ -2788,7 +2937,7 @@ libcrun_container_restore (libcrun_conte
   if (def->oci_version && strstr (def->oci_version, "1.0") == NULL)
     return crun_make_error (err, 0, "unknown version specified");
 
-  ret = check_config_file (def, err);
+  ret = check_config_file (def, context, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
@@ -2864,7 +3013,7 @@ libcrun_container_restore (libcrun_conte
     {
       char buf[12];
       size_t buf_len = sprintf (buf, "%d", status.pid);
-      ret = write_file (context->pid_file, buf, buf_len, err);
+      ret = write_file_with_flags (context->pid_file, O_CREAT | O_TRUNC, buf, buf_len, err);
       if (UNLIKELY (ret < 0))
         return ret;
     }
diff -pruN 0.15+dfsg-1/src/libcrun/container.h 0.15.1+dfsg-1/src/libcrun/container.h
--- 0.15+dfsg-1/src/libcrun/container.h	2020-09-03 11:43:25.000000000 +0000
+++ 0.15.1+dfsg-1/src/libcrun/container.h	2020-10-22 10:44:51.000000000 +0000
@@ -45,6 +45,9 @@ struct libcrun_context_s
   bool no_new_keyring;
   bool force_no_cgroup;
   bool no_pivot;
+
+  int (*exec_func) (void *container, void *arg, const char *pathname, char *const argv[]);
+  void *exec_func_arg;
 };
 
 enum
diff -pruN 0.15+dfsg-1/src/libcrun/linux.c 0.15.1+dfsg-1/src/libcrun/linux.c
--- 0.15+dfsg-1/src/libcrun/linux.c	2020-09-23 14:47:06.000000000 +0000
+++ 0.15.1+dfsg-1/src/libcrun/linux.c	2020-11-02 15:37:17.000000000 +0000
@@ -168,7 +168,7 @@ syscall_fsopen (const char *fs_name, uns
 #if defined __NR_fsopen
   return (int) syscall (__NR_fsopen, fs_name, flags);
 #else
-  errno = ENOTSUP;
+  errno = ENOSYS;
   return -1;
 #endif
 }
@@ -179,7 +179,7 @@ syscall_fsmount (int fsfd, unsigned int
 #if defined __NR_fsmount
   return (int) syscall (__NR_fsmount, fsfd, flags, attr_flags);
 #else
-  errno = ENOTSUP;
+  errno = ENOSYS;
   return -1;
 #endif
 }
@@ -190,7 +190,7 @@ syscall_fsconfig (int fsfd, unsigned int
 #if defined __NR_fsconfig
   return (int) syscall (__NR_fsconfig, fsfd, cmd, key, val, aux);
 #else
-  errno = ENOTSUP;
+  errno = ENOSYS;
   return -1;
 #endif
 }
@@ -202,7 +202,7 @@ syscall_move_mount (int from_dfd, const
 #if defined __NR_move_mount
   return (int) syscall (__NR_move_mount, from_dfd, from_pathname, to_dfd, to_pathname, flags);
 #else
-  errno = ENOTSUP;
+  errno = ENOSYS;
   return -1;
 #endif
 }
@@ -222,7 +222,7 @@ syscall_pidfd_open (pid_t pid, unsigned
 #else
   (void) pid;
   (void) flags;
-  errno = ENOTSUP;
+  errno = ENOSYS;
   return -1;
 #endif
 }
@@ -237,7 +237,7 @@ syscall_pidfd_send_signal (int pidfd, in
   (void) sig;
   (void) info;
   (void) flags;
-  errno = ENOTSUP;
+  errno = ENOSYS;
   return -1;
 #endif
 }
@@ -399,6 +399,11 @@ do_remount (int targetfd, const char *ta
       real_target = target_buffer;
     }
 
+  /* Older kernels (seen on 4.18) fail with EINVAL if data is set when
+     setting MS_RDONLY.  */
+  if (flags & (MS_REMOUNT | MS_RDONLY))
+    data = NULL;
+
   ret = mount (NULL, real_target, NULL, flags, data);
   if (UNLIKELY (ret < 0))
     {
@@ -417,15 +422,15 @@ do_remount (int targetfd, const char *ta
           if (LIKELY (ret == 0))
             return 0;
 
-          /* If it still fails try to add MS_RDONLY.  */
-          if ((sfs.f_flags & MS_RDONLY) && ((flags & MS_RDONLY) == 0))
+          /* If it still fails and MS_RDONLY is present in the mount, try adding it.  */
+          if (sfs.f_flags & MS_RDONLY)
             {
               remount_flags = sfs.f_flags & (MS_NOSUID | MS_NODEV | MS_NOEXEC | MS_RDONLY);
-              ret = mount ("none", real_target, "", flags | remount_flags, data);
+              ret = mount (NULL, real_target, NULL, flags | remount_flags, data);
             }
         }
       if (UNLIKELY (ret < 0))
-        return crun_make_error (err, errno, "remount `%s`", target);
+	return crun_make_error (err, errno, "remount `%s`", target);
     }
   return 0;
 }
@@ -493,7 +498,7 @@ fsopen_mount (runtime_spec_schema_defs_m
   (void) syscall_fsopen;
   (void) syscall_fsconfig;
   (void) syscall_fsmount;
-  errno = ENOTSUP;
+  errno = ENOSYS;
   return -1;
 #endif
 }
@@ -505,7 +510,7 @@ fs_move_mount_to (int fd, int dirfd, con
   return syscall_move_mount (fd, "", dirfd, name, MOVE_MOUNT_F_EMPTY_PATH);
 #else
   (void) syscall_move_mount;
-  errno = ENOTSUP;
+  errno = ENOSYS;
   return -1;
 #endif
 }
@@ -798,7 +803,7 @@ do_mount_cgroup_v1 (libcrun_container_t
   if (UNLIKELY (subsystems == NULL))
     return -1;
 
-  ret = do_mount (container, source, targetfd, target, "tmpfs", mountflags & ~MS_RDONLY, "size=1024k", LABEL_NONE, err);
+  ret = do_mount (container, source, targetfd, target, "tmpfs", mountflags & ~MS_RDONLY, "size=1024k", LABEL_MOUNT, err);
   if (UNLIKELY (ret < 0))
     return ret;
 
@@ -1788,6 +1793,9 @@ libcrun_set_mounts (libcrun_container_t
   __attribute__ ((cleanup (cleanup_rmdir))) char *tmpdirparent = NULL;
   int rootfsfd = -1;
 
+  if (rootfs == NULL || def->mounts == NULL)
+    return 0;
+
   if (def->linux->rootfs_propagation)
     rootfs_propagation = get_mount_flags (def->linux->rootfs_propagation, 0, NULL, NULL);
 
@@ -2956,6 +2964,7 @@ configure_init_status (struct init_statu
     {
       libcrun_warning ("non root user need to have an 'user' namespace");
       ns->all_namespaces |= CLONE_NEWUSER;
+      ns->namespaces_to_unshare |= CLONE_NEWUSER;
     }
 
   return 0;
@@ -3138,9 +3147,12 @@ libcrun_run_linux_container (libcrun_con
   sync_socket_container = sync_socket[1];
 
 #ifdef HAVE_SYSTEMD
-  ret = do_notify_socket (container, def->root->path, err);
-  if (UNLIKELY (ret < 0))
-    return ret;
+  if (def->root)
+    {
+      ret = do_notify_socket (container, def->root->path, err);
+      if (UNLIKELY (ret < 0))
+        return ret;
+    }
 #endif
 
   get_uid_gid_from_def (container->container_def, &container->container_uid, &container->container_gid);
@@ -3729,7 +3741,7 @@ libcrun_kill_linux (libcrun_container_st
   if (UNLIKELY (pidfd < 0))
     {
       /* If pidfd_open is not supported, fallback to kill.  */
-      if (errno == ENOTSUP)
+      if (errno == ENOSYS)
         {
           ret = kill (status->pid, signal);
           if (UNLIKELY (ret < 0))
diff -pruN 0.15+dfsg-1/src/libcrun/seccomp_notify.c 0.15.1+dfsg-1/src/libcrun/seccomp_notify.c
--- 0.15+dfsg-1/src/libcrun/seccomp_notify.c	2020-09-03 11:43:25.000000000 +0000
+++ 0.15.1+dfsg-1/src/libcrun/seccomp_notify.c	2020-11-02 15:37:17.000000000 +0000
@@ -165,7 +165,11 @@ libcrun_seccomp_notify_plugins (struct s
 
   ret = ioctl (seccomp_fd, SECCOMP_IOCTL_NOTIF_RECV, ctx->sreq);
   if (UNLIKELY (ret < 0))
-    return crun_make_error (err, errno, "ioctl");
+    {
+      if (errno == ENOENT)
+        return 0;
+      return crun_make_error (err, errno, "ioctl");
+    }
 
   for (i = 0; i < ctx->n_plugins; i++)
     {
diff -pruN 0.15+dfsg-1/src/libcrun/utils.c 0.15.1+dfsg-1/src/libcrun/utils.c
--- 0.15+dfsg-1/src/libcrun/utils.c	2020-09-22 18:17:19.000000000 +0000
+++ 0.15.1+dfsg-1/src/libcrun/utils.c	2020-10-22 10:44:51.000000000 +0000
@@ -111,9 +111,9 @@ write_file_at (int dirfd, const char *na
 }
 
 int
-write_file (const char *name, const void *data, size_t len, libcrun_error_t *err)
+write_file_with_flags (const char *name, int flags, const void *data, size_t len, libcrun_error_t *err)
 {
-  cleanup_close int fd = open (name, O_WRONLY | O_CREAT, 0700);
+  cleanup_close int fd = open (name, O_WRONLY | flags, 0700);
   int ret;
   if (UNLIKELY (fd < 0))
     return crun_make_error (err, errno, "opening file `%s` for writing", name);
@@ -126,6 +126,12 @@ write_file (const char *name, const void
 }
 
 int
+write_file (const char *name, const void *data, size_t len, libcrun_error_t *err)
+{
+  return write_file_with_flags (name, O_CREAT, data, len, err);
+}
+
+int
 detach_process ()
 {
   pid_t pid;
@@ -223,48 +229,39 @@ ensure_directory_internal_at (int dirfd,
 {
   char *it = path + len;
   int ret = 0;
-  int parent_created;
+  bool parent_created = false;
 
-  for (parent_created = 0; parent_created < 2; parent_created++)
+  for (;;)
     {
       ret = mkdirat (dirfd, path, mode);
-      if (ret == 0)
-        break;
-
-      if (errno == EEXIST)
-        {
-          ret = 0;
-          break;
-        }
+      if (ret == 0 || errno == EEXIST)
+        return 0;
 
-      if (errno != ENOENT || parent_created)
+      if (parent_created || errno != ENOENT)
         {
           /* On errors check if the directory already exists.  */
           ret = crun_dir_p (path, false, err);
           if (ret > 0)
-            break;
+            return 0;
 
           return crun_make_error (err, errno, "create directory `%s`", path);
         }
-      else
+
+      while (it > path && *it != '/')
         {
-          while (it > path && *it != '/')
-            {
-              it--;
-              len--;
-            }
-          if (it == path)
-            {
-              ret = 0;
-              break;
-            }
-
-          *it = '\0';
-          ret = ensure_directory_internal_at (dirfd, path, len - 1, mode, err);
-          *it = '/';
-          if (UNLIKELY (ret < 0))
-            break;
+          it--;
+          len--;
         }
+      if (it == path)
+        return 0;
+
+      *it = '\0';
+      ret = ensure_directory_internal_at (dirfd, path, len - 1, mode, err);
+      *it = '/';
+      if (UNLIKELY (ret < 0))
+        return ret;
+
+      parent_created = true;
     }
   return ret;
 }
diff -pruN 0.15+dfsg-1/src/libcrun/utils.h 0.15.1+dfsg-1/src/libcrun/utils.h
--- 0.15+dfsg-1/src/libcrun/utils.h	2020-09-03 11:43:25.000000000 +0000
+++ 0.15.1+dfsg-1/src/libcrun/utils.h	2020-10-22 10:44:51.000000000 +0000
@@ -149,6 +149,8 @@ int xasprintf (char **str, const char *f
 
 int crun_path_exists (const char *path, libcrun_error_t *err);
 
+int write_file_with_flags (const char *name, int flags, const void *data, size_t len, libcrun_error_t *err);
+
 int write_file (const char *name, const void *data, size_t len, libcrun_error_t *err);
 
 int write_file_at (int dirfd, const char *name, const void *data, size_t len, libcrun_error_t *err);
diff -pruN 0.15+dfsg-1/src/run.c 0.15.1+dfsg-1/src/run.c
--- 0.15+dfsg-1/src/run.c	2020-09-03 11:43:25.000000000 +0000
+++ 0.15.1+dfsg-1/src/run.c	2020-10-22 10:44:51.000000000 +0000
@@ -50,7 +50,7 @@ static struct argp_option options[]
         { "detach", 'd', 0, 0, "detach from the parent", 0 },
         { "console-socket", OPTION_CONSOLE_SOCKET, "SOCKET", 0,
           "path to a socket that will receive the ptmx end of the tty", 0 },
-        { "preserve-fds", OPTION_PRESERVE_FDS, 0, 0, "pass additional FDs to the container", 0 },
+        { "preserve-fds", OPTION_PRESERVE_FDS, "N", 0, "pass additional FDs to the container", 0 },
         { "pid-file", OPTION_PID_FILE, "FILE", 0, "where to write the PID of the container", 0 },
         { "no-subreaper", OPTION_NO_SUBREAPER, 0, 0, "do not create a subreaper process", 0 },
         { "no-new-keyring", OPTION_NO_NEW_KEYRING, 0, 0, "keep the same session key", 0 },
diff -pruN 0.15+dfsg-1/.tarball-version 0.15.1+dfsg-1/.tarball-version
--- 0.15+dfsg-1/.tarball-version	2020-09-23 14:49:11.000000000 +0000
+++ 0.15.1+dfsg-1/.tarball-version	2020-11-03 15:18:31.000000000 +0000
@@ -1 +1 @@
-0.15
+0.15.1
diff -pruN 0.15+dfsg-1/.version 0.15.1+dfsg-1/.version
--- 0.15+dfsg-1/.version	2020-09-23 14:49:06.000000000 +0000
+++ 0.15.1+dfsg-1/.version	2020-11-03 15:18:22.000000000 +0000
@@ -1 +1 @@
-0.15
+0.15.1
